Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -6299,87 +5974,176 @@
           ENDIF
 
-       CASE ( 't_surf_wall_h' )
+       CASE ( 't_surf_wall_h(0)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_wall_h_1 ) )   ALLOCATE( t_surf_wall_h_1(1:surf_usm_h%ns) )
-             READ ( 13 )  tmp_surf_wall_h
-          ENDIF
-          CALL surface_restore_elements( t_surf_wall_h_1, tmp_surf_wall_h, surf_usm_h%start_index, &
-                                         start_index_on_file, end_index_on_file, nxlc, nysc,       &
-                                         nxlf, nxrf, nysf, nynf, nys_on_file, nyn_on_file,         &
-                                         nxl_on_file, nxr_on_file )
+             IF ( .NOT.  ALLOCATED( t_surf_wall_h_1(0)%val ) )                                       &
+                ALLOCATE( t_surf_wall_h_1(0)%val(1:surf_usm_h(0)%ns) )
+             READ ( 13 )  tmp_surf_wall_h(0)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_wall_h_1(0)%val, tmp_surf_wall_h(0)%val,               &
+                                         surf_usm_h(0)%start_index, start_index_on_file,           &
+                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
+                                         nys_on_file, nyn_on_file, nxl_on_file, nxr_on_file )
+
+       CASE ( 't_surf_wall_h(1)' )
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( t_surf_wall_h_1(1)%val ) )                                       &
+                ALLOCATE( t_surf_wall_h_1(1)%val(1:surf_usm_h(1)%ns) )
+             READ ( 13 )  tmp_surf_wall_h(1)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_wall_h_1(1)%val, tmp_surf_wall_h(1)%val,               &
+                                         surf_usm_h(1)%start_index, start_index_on_file,           &
+                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
+                                         nys_on_file, nyn_on_file, nxl_on_file, nxr_on_file )
 
        CASE ( 't_surf_wall_v(0)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(0)%t ) )                                       &
-                ALLOCATE( t_surf_wall_v_1(0)%t(1:surf_usm_v(0)%ns) )
-             READ ( 13 )  tmp_surf_wall_v(0)%t
-          ENDIF
-          CALL surface_restore_elements( t_surf_wall_v_1(0)%t, tmp_surf_wall_v(0)%t,               &
+             IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(0)%val ) )                                       &
+                ALLOCATE( t_surf_wall_v_1(0)%val(1:surf_usm_v(0)%ns) )
+             READ ( 13 )  tmp_surf_wall_v(0)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_wall_v_1(0)%val, tmp_surf_wall_v(0)%val,               &
+                                         surf_usm_v(0)%start_index, start_index_on_file,           &
+                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
+                                         nys_on_file, nyn_on_file, nxl_on_file, nxr_on_file )
+
+       CASE ( 't_surf_wall_v(1)' )
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(1)%val ) )                                       &
+                ALLOCATE( t_surf_wall_v_1(1)%val(1:surf_usm_v(1)%ns) )
+             READ ( 13 )  tmp_surf_wall_v(1)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_wall_v_1(1)%val, tmp_surf_wall_v(1)%val,               &
+                                         surf_usm_v(1)%start_index, start_index_on_file,           &
+                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
+                                         nys_on_file, nyn_on_file, nxl_on_file, nxr_on_file )
+
+       CASE ( 't_surf_wall_v(2)' )
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(2)%val ) )                                       &
+                ALLOCATE( t_surf_wall_v_1(2)%val(1:surf_usm_v(2)%ns) )
+             READ ( 13 )  tmp_surf_wall_v(2)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_wall_v_1(2)%val, tmp_surf_wall_v(2)%val,               &
+                                         surf_usm_v(2)%start_index, start_index_on_file,           &
+                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
+                                         nys_on_file, nyn_on_file, nxl_on_file, nxr_on_file )
+
+       CASE ( 't_surf_wall_v(3)' )
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(3)%val ) )                                       &
+                ALLOCATE( t_surf_wall_v_1(3)%val(1:surf_usm_v(3)%ns) )
+             READ ( 13 )  tmp_surf_wall_v(3)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_wall_v_1(3)%val, tmp_surf_wall_v(3)%val,               &
+                                         surf_usm_v(3)%start_index, start_index_on_file,           &
+                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
+                                         nys_on_file, nyn_on_file, nxl_on_file, nxr_on_file )
+
+       CASE ( 't_surf_window_h(0)' )
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( t_surf_window_h_1(0)%val ) )                                     &
+                ALLOCATE( t_surf_window_h_1(0)%val(1:surf_usm_h(0)%ns) )
+             READ ( 13 )  tmp_surf_window_h(0)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_window_h_1(0)%val, tmp_surf_window_h(0)%val,           &
+                                         surf_usm_h(0)%start_index, start_index_on_file,           &
+                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
+                                         nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
+
+       CASE ( 't_surf_window_h(1)' )
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( t_surf_window_h_1(1)%val ) )                                     &
+                ALLOCATE( t_surf_window_h_1(1)%val(1:surf_usm_h(1)%ns) )
+             READ ( 13 )  tmp_surf_window_h(1)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_window_h_1(1)%val, tmp_surf_window_h(1)%val,           &
+                                         surf_usm_h(1)%start_index, start_index_on_file,           &
+                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
+                                         nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
+
+       CASE ( 't_surf_window_v(0)' )
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( t_surf_window_v_1(0)%val ) )                                     &
+                ALLOCATE( t_surf_window_v_1(0)%val(1:surf_usm_v(0)%ns) )
+             READ ( 13 )  tmp_surf_window_v(0)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_window_v_1(0)%val, tmp_surf_window_v(0)%val,           &
                                          surf_usm_v(0)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
                                          nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
-       CASE ( 't_surf_wall_v(1)' )
+       CASE ( 't_surf_window_v(1)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(1)%t ) )                                       &
-                ALLOCATE( t_surf_wall_v_1(1)%t(1:surf_usm_v(1)%ns) )
-             READ ( 13 )  tmp_surf_wall_v(1)%t
-          ENDIF
-          CALL surface_restore_elements( t_surf_wall_v_1(1)%t, tmp_surf_wall_v(1)%t,               &
+             IF ( .NOT.  ALLOCATED( t_surf_window_v_1(1)%val ) )                                   &
+                ALLOCATE( t_surf_window_v_1(1)%val(1:surf_usm_v(1)%ns) )
+             READ ( 13 )  tmp_surf_window_v(1)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_window_v_1(1)%val, tmp_surf_window_v(1)%val,       &
                                          surf_usm_v(1)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
                                          nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
-       CASE ( 't_surf_wall_v(2)' )
+       CASE ( 't_surf_window_v(2)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(2)%t ) )                                       &
-                ALLOCATE( t_surf_wall_v_1(2)%t(1:surf_usm_v(2)%ns) )
-             READ ( 13 )  tmp_surf_wall_v(2)%t
-          ENDIF
-          CALL surface_restore_elements( t_surf_wall_v_1(2)%t, tmp_surf_wall_v(2)%t,               &
+             IF ( .NOT.  ALLOCATED( t_surf_window_v_1(2)%val ) )                                   &
+                ALLOCATE( t_surf_window_v_1(2)%val(1:surf_usm_v(2)%ns) )
+             READ ( 13 )  tmp_surf_window_v(2)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_window_v_1(2)%val, tmp_surf_window_v(2)%val,       &
                                          surf_usm_v(2)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
                                          nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
-       CASE ( 't_surf_wall_v(3)' )
+       CASE ( 't_surf_window_v(3)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_wall_v_1(3)%t ) )                                       &
-                ALLOCATE( t_surf_wall_v_1(3)%t(1:surf_usm_v(3)%ns) )
-             READ ( 13 )  tmp_surf_wall_v(3)%t
-          ENDIF
-          CALL surface_restore_elements( t_surf_wall_v_1(3)%t, tmp_surf_wall_v(3)%t,               &
+             IF ( .NOT.  ALLOCATED( t_surf_window_v_1(3)%val ) )                                   &
+                ALLOCATE( t_surf_window_v_1(3)%val(1:surf_usm_v(3)%ns) )
+             READ ( 13 )  tmp_surf_window_v(3)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_window_v_1(3)%val, tmp_surf_window_v(3)%val,       &
                                          surf_usm_v(3)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
                                          nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
-       CASE ( 't_surf_green_h' )
+       CASE ( 't_surf_green_h(0)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_green_h_1 ) )                                           &
-                ALLOCATE( t_surf_green_h_1(1:surf_usm_h%ns) )
-             READ ( 13 )  tmp_surf_green_h
-          ENDIF
-          CALL surface_restore_elements( t_surf_green_h_1, tmp_surf_green_h,                       &
-                                         surf_usm_h%start_index, start_index_on_file,              &
+             IF ( .NOT.  ALLOCATED( t_surf_green_h_1(0)%val ) )                                      &
+                ALLOCATE( t_surf_green_h_1(0)%val(1:surf_usm_h(0)%ns) )
+             READ ( 13 )  tmp_surf_green_h(0)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_green_h_1(0)%val, tmp_surf_green_h(0)%val,             &
+                                         surf_usm_h(0)%start_index, start_index_on_file,         &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
-                                         nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
+                                         nys_on_file, nyn_on_file, nxl_on_file, nxr_on_file )
+
+       CASE ( 't_surf_green_h(1)' )
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( t_surf_green_h_1(1)%val ) )                                      &
+                ALLOCATE( t_surf_green_h_1(1)%val(1:surf_usm_h(1)%ns) )
+             READ ( 13 )  tmp_surf_green_h(1)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_green_h_1(1)%val, tmp_surf_green_h(1)%val,             &
+                                         surf_usm_h(1)%start_index, start_index_on_file,         &
+                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
+                                         nys_on_file, nyn_on_file, nxl_on_file, nxr_on_file )
 
        CASE ( 't_surf_green_v(0)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_green_v_1(0)%t ) )                                      &
-                ALLOCATE( t_surf_green_v_1(0)%t(1:surf_usm_v(0)%ns) )
-             READ ( 13 )  tmp_surf_green_v(0)%t
-          ENDIF
-          CALL surface_restore_elements( t_surf_green_v_1(0)%t, tmp_surf_green_v(0)%t,             &
+             IF ( .NOT.  ALLOCATED( t_surf_green_v_1(0)%val ) )                                      &
+                ALLOCATE( t_surf_green_v_1(0)%val(1:surf_usm_v(0)%ns) )
+             READ ( 13 )  tmp_surf_green_v(0)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_green_v_1(0)%val, tmp_surf_green_v(0)%val,             &
                                          surf_usm_v(0)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
-                                         nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
+                                         nys_on_file, nyn_on_file, nxl_on_file, nxr_on_file )
 
        CASE ( 't_surf_green_v(1)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_green_v_1(1)%t ) )                                      &
-                ALLOCATE( t_surf_green_v_1(1)%t(1:surf_usm_v(1)%ns) )
-             READ ( 13 )  tmp_surf_green_v(1)%t
-          ENDIF
-          CALL surface_restore_elements( t_surf_green_v_1(1)%t, tmp_surf_green_v(1)%t,             &
+             IF ( .NOT.  ALLOCATED( t_surf_green_v_1(1)%val ) )                                      &
+                ALLOCATE( t_surf_green_v_1(1)%val(1:surf_usm_v(1)%ns) )
+             READ ( 13 )  tmp_surf_green_v(1)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_green_v_1(1)%val, tmp_surf_green_v(1)%val,             &
                                          surf_usm_v(1)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
@@ -6388,9 +6152,9 @@
        CASE ( 't_surf_green_v(2)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_green_v_1(2)%t ) )                                      &
-                ALLOCATE( t_surf_green_v_1(2)%t(1:surf_usm_v(2)%ns) )
-             READ ( 13 )  tmp_surf_green_v(2)%t
-          ENDIF
-          CALL surface_restore_elements( t_surf_green_v_1(2)%t, tmp_surf_green_v(2)%t,             &
+             IF ( .NOT.  ALLOCATED( t_surf_green_v_1(2)%val ) )                                      &
+                ALLOCATE( t_surf_green_v_1(2)%val(1:surf_usm_v(2)%ns) )
+             READ ( 13 )  tmp_surf_green_v(2)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_green_v_1(2)%val, tmp_surf_green_v(2)%val,             &
                                          surf_usm_v(2)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
@@ -6399,89 +6163,57 @@
        CASE ( 't_surf_green_v(3)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_green_v_1(3)%t ) )                                      &
-                ALLOCATE( t_surf_green_v_1(3)%t(1:surf_usm_v(3)%ns) )
-             READ ( 13 )  tmp_surf_green_v(3)%t
-          ENDIF
-          CALL surface_restore_elements( t_surf_green_v_1(3)%t, tmp_surf_green_v(3)%t,             &
+             IF ( .NOT.  ALLOCATED( t_surf_green_v_1(3)%val ) )                                      &
+                ALLOCATE( t_surf_green_v_1(3)%val(1:surf_usm_v(3)%ns) )
+             READ ( 13 )  tmp_surf_green_v(3)%val
+          ENDIF
+          CALL surface_restore_elements( t_surf_green_v_1(3)%val, tmp_surf_green_v(3)%val,             &
                                          surf_usm_v(3)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
                                          nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
-       CASE ( 't_surf_window_h' )
+       CASE ( 'm_liq_usm_h(0)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_window_h_1 ) )                                          &
-                ALLOCATE( t_surf_window_h_1(1:surf_usm_h%ns) )
-             READ ( 13 )  tmp_surf_window_h
-          ENDIF
-          CALL surface_restore_elements( t_surf_window_h_1, tmp_surf_window_h,                     &
-                                         surf_usm_h%start_index, start_index_on_file,              &
+             IF ( .NOT.  ALLOCATED( m_liq_usm_h(0)%val ) )                                         &
+                ALLOCATE( m_liq_usm_h(0)%val(1:surf_usm_h(0)%ns) )
+             READ ( 13 )  tmp_surf_mliq_h(0)%val
+          ENDIF
+          CALL surface_restore_elements( m_liq_usm_h(0)%val, tmp_surf_mliq_h(0)%val,               &
+                                         surf_usm_h(0)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
                                          nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
-       CASE ( 't_surf_window_v(0)' )
+       CASE ( 'm_liq_usm_h(1)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_window_v_1(0)%t ) )                                     &
-                ALLOCATE( t_surf_window_v_1(0)%t(1:surf_usm_v(0)%ns) )
-             READ ( 13 )  tmp_surf_window_v(0)%t
-          ENDIF
-          CALL surface_restore_elements( t_surf_window_v_1(0)%t, tmp_surf_window_v(0)%t,           &
-                                         surf_usm_v(0)%start_index, start_index_on_file,           &
+             IF ( .NOT.  ALLOCATED( m_liq_usm_h(1)%val ) )                                         &
+                ALLOCATE( m_liq_usm_h(1)%val(1:surf_usm_h(1)%ns) )
+             READ ( 13 )  tmp_surf_mliq_h(1)%val
+          ENDIF
+          CALL surface_restore_elements( m_liq_usm_h(1)%val, tmp_surf_mliq_h(1)%val,               &
+                                         surf_usm_h(1)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
                                          nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
-       CASE ( 't_surf_window_v(1)' )
+       CASE ( 'waste_heat_h(0)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_window_v_1(1)%t ) )                                     &
-                ALLOCATE( t_surf_window_v_1(1)%t(1:surf_usm_v(1)%ns) )
-             READ ( 13 )  tmp_surf_window_v(1)%t
-          ENDIF
-          CALL surface_restore_elements( t_surf_window_v_1(1)%t, tmp_surf_window_v(1)%t,           &
-                                         surf_usm_v(1)%start_index, start_index_on_file,           &
+             IF ( .NOT.  ALLOCATED( surf_usm_h(0)%waste_heat ) )                                   &
+                ALLOCATE( surf_usm_h(0)%waste_heat(1:surf_usm_h(0)%ns) )
+             READ ( 13 )  tmp_surf_waste_h(0)%val
+          ENDIF
+          CALL surface_restore_elements( surf_usm_h(0)%waste_heat, tmp_surf_waste_h(0)%val,          &
+                                         surf_usm_h(0)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
                                          nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
-       CASE ( 't_surf_window_v(2)' )
+       CASE ( 'waste_heat_h(1)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_window_v_1(2)%t ) )                                     &
-                ALLOCATE( t_surf_window_v_1(2)%t(1:surf_usm_v(2)%ns) )
-             READ ( 13 )  tmp_surf_window_v(2)%t
-          ENDIF
-          CALL surface_restore_elements( t_surf_window_v_1(2)%t, tmp_surf_window_v(2)%t,           &
-                                         surf_usm_v(2)%start_index, start_index_on_file,           &
+             IF ( .NOT.  ALLOCATED( surf_usm_h(1)%waste_heat ) )                                   &
+                ALLOCATE( surf_usm_h(1)%waste_heat(1:surf_usm_h(1)%ns) )
+             READ ( 13 )  tmp_surf_waste_h(1)%val
+          ENDIF
+          CALL surface_restore_elements( surf_usm_h(1)%waste_heat, tmp_surf_waste_h(1)%val,          &
+                                         surf_usm_h(1)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
                                          nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
-       CASE ( 't_surf_window_v(3)' )
-          IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_surf_window_v_1(3)%t ) )                                     &
-                ALLOCATE( t_surf_window_v_1(3)%t(1:surf_usm_v(3)%ns) )
-             READ ( 13 )  tmp_surf_window_v(3)%t
-          ENDIF
-          CALL surface_restore_elements( t_surf_window_v_1(3)%t, tmp_surf_window_v(3)%t,           &
-                                         surf_usm_v(3)%start_index, start_index_on_file,           &
-                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
-                                         nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
-
-       CASE ( 'm_liq_usm_h' )
-          IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( m_liq_usm_h%var_usm_1d ) )                                     &
-                ALLOCATE( m_liq_usm_h%var_usm_1d(1:surf_usm_h%ns) )
-             READ ( 13 )  tmp_surf_mliq_h
-          ENDIF
-          CALL surface_restore_elements( m_liq_usm_h%var_usm_1d, tmp_surf_mliq_h,                  &
-                                         surf_usm_h%start_index, start_index_on_file,              &
-                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
-                                         nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
-
-       CASE ( 'waste_heat_h' )
-          IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( surf_usm_h%waste_heat ) )                                      &
-                ALLOCATE( surf_usm_h%waste_heat(1:surf_usm_h%ns) )
-             READ ( 13 )  tmp_surf_waste_h
-          ENDIF
-          CALL surface_restore_elements( surf_usm_h%waste_heat, tmp_surf_waste_h,                  &
-                                         surf_usm_h%start_index, start_index_on_file,              &
-                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
-                                         nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
        CASE ( 'waste_heat_v(0)' )
@@ -6489,7 +6221,7 @@
              IF ( .NOT.  ALLOCATED( surf_usm_v(0)%waste_heat ) )                                   &
                 ALLOCATE( surf_usm_v(0)%waste_heat(1:surf_usm_v(0)%ns) )
-             READ ( 13 )  tmp_surf_waste_v(0)%t
-          ENDIF
-          CALL surface_restore_elements( surf_usm_v(0)%waste_heat, tmp_surf_waste_v(0)%t,          &
+             READ ( 13 )  tmp_surf_waste_v(0)%val
+          ENDIF
+          CALL surface_restore_elements( surf_usm_v(0)%waste_heat, tmp_surf_waste_v(0)%val,          &
                                          surf_usm_v(0)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
@@ -6500,7 +6232,7 @@
              IF ( .NOT.  ALLOCATED( surf_usm_v(1)%waste_heat ) )                                   &
                 ALLOCATE( surf_usm_v(1)%waste_heat(1:surf_usm_v(1)%ns) )
-             READ ( 13 )  tmp_surf_waste_v(1)%t
-          ENDIF
-          CALL surface_restore_elements( surf_usm_v(1)%waste_heat, tmp_surf_waste_v(1)%t,          &
+             READ ( 13 )  tmp_surf_waste_v(1)%val
+          ENDIF
+          CALL surface_restore_elements( surf_usm_v(1)%waste_heat, tmp_surf_waste_v(1)%val,          &
                                          surf_usm_v(1)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
@@ -6511,7 +6243,7 @@
              IF ( .NOT.  ALLOCATED( surf_usm_v(2)%waste_heat ) )                                   &
                 ALLOCATE( surf_usm_v(2)%waste_heat(1:surf_usm_v(2)%ns) )
-             READ ( 13 )  tmp_surf_waste_v(2)%t
-          ENDIF
-          CALL surface_restore_elements( surf_usm_v(2)%waste_heat, tmp_surf_waste_v(2)%t,          &
+             READ ( 13 )  tmp_surf_waste_v(2)%val
+          ENDIF
+          CALL surface_restore_elements( surf_usm_v(2)%waste_heat, tmp_surf_waste_v(2)%val,          &
                                          surf_usm_v(2)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
@@ -6522,32 +6254,40 @@
              IF ( .NOT.  ALLOCATED( surf_usm_v(3)%waste_heat ) )                                   &
                 ALLOCATE( surf_usm_v(3)%waste_heat(1:surf_usm_v(3)%ns) )
-             READ ( 13 )  tmp_surf_waste_v(3)%t
-          ENDIF
-          CALL surface_restore_elements( surf_usm_v(3)%waste_heat, tmp_surf_waste_v(3)%t,          &
+             READ ( 13 )  tmp_surf_waste_v(3)%val
+          ENDIF
+          CALL surface_restore_elements( surf_usm_v(3)%waste_heat, tmp_surf_waste_v(3)%val,          &
                                          surf_usm_v(3)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
                                          nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
-       CASE ( 't_wall_h' )
+       CASE ( 't_wall_h(0)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_wall_h_1 ) )                                                 &
-                ALLOCATE( t_wall_h_1(nzb_wall:nzt_wall+1, 1:surf_usm_h%ns) )
-             READ ( 13 )  tmp_wall_h
-          ENDIF
-          CALL surface_restore_elements( t_wall_h_1, tmp_wall_h, surf_usm_h%start_index,           &
-                                         start_index_on_file, end_index_on_file,                   &
-                                         nxlc, nysc, nxlf, nxrf, nysf, nynf,                       &
+             IF ( .NOT.  ALLOCATED( t_wall_h_1(0)%val ) )                                            &
+                ALLOCATE( t_wall_h_1(0)%val(nzb_wall:nzt_wall+1, 1:surf_usm_h(0)%ns) )
+             READ ( 13 )  tmp_wall_h(0)%val
+          ENDIF
+          CALL surface_restore_elements( t_wall_h_1(0)%val, tmp_wall_h(0)%val,                         &
+                                         surf_usm_h(0)%start_index, start_index_on_file,           &
+                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
                                          nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
-
-
+       CASE ( 't_wall_h(1)' )
+          IF ( k == 1 )  THEN
+             IF ( .NOT.  ALLOCATED( t_wall_h_1(1)%val ) )                                            &
+                ALLOCATE( t_wall_h_1(1)%val(nzb_wall:nzt_wall+1, 1:surf_usm_h(1)%ns) )
+             READ ( 13 )  tmp_wall_h(1)%val
+          ENDIF
+          CALL surface_restore_elements( t_wall_h_1(1)%val, tmp_wall_h(1)%val,                         &
+                                         surf_usm_h(1)%start_index, start_index_on_file,           &
+                                         end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
+                                         nys_on_file, nyn_on_file, nxl_on_file,nxr_on_file )
 
        CASE ( 't_wall_v(0)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_wall_v_1(0)%t ) )                                            &
-                ALLOCATE( t_wall_v_1(0)%t(nzb_wall:nzt_wall+1, 1:surf_usm_v(0)%ns) )
-             READ ( 13 )  tmp_wall_v(0)%t
-          ENDIF
-          CALL surface_restore_elements( t_wall_v_1(0)%t, tmp_wall_v(0)%t,                         &
+             IF ( .NOT.  ALLOCATED( t_wall_v_1(0)%val ) )                                            &
+                ALLOCATE( t_wall_v_1(0)%val(nzb_wall:nzt_wall+1, 1:surf_usm_v(0)%ns) )
+             READ ( 13 )  tmp_wall_v(0)%val
+          ENDIF
+          CALL surface_restore_elements( t_wall_v_1(0)%val, tmp_wall_v(0)%val,                         &
                                          surf_usm_v(0)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
@@ -6556,9 +6296,9 @@
        CASE ( 't_wall_v(1)' )
           IF ( k == 1 )  THEN
-             IF ( .NOT.  ALLOCATED( t_wall_v_1(1)%t ) )                                            &
-                ALLOCATE( t_wall_v_1(1)%t(nzb_wall:nzt_wall+1, 1:surf_usm_v(1)%ns) )
-             READ ( 13 )  tmp_wall_v(1)%t
-          ENDIF
-          CALL surface_restore_elements( t_wall_v_1(1)%t, tmp_wall_v(1)%t,                         &
+             IF ( .NOT.  ALLOCATED( t_wall_v_1(1)%val ) )                                            &
+                ALLOCATE( t_wall_v_1(1)%val(nzb_wall:nzt_wall+1, 1:surf_usm_v(1)%ns) )
+             READ ( 13 )  tmp_wall_v(1)%val
+          ENDIF
+          CALL surface_restore_elements( t_wall_v_1(1)%val, tmp_wall_v(1)%val,                         &
                                          surf_usm_v(1)%start_index, start_index_on_file,           &
                                          end_index_on_file, nxlc, nysc, nxlf, nxrf, nysf, nynf,    &
